import request from '@/utils/request'

// 查询章节列表
export function listChapter(auditId) {
  return request({
    url: '/rc/meeting/listChapter/' + auditId,
    method: 'get'
  })
}

// 查询CODE列表
export function listCode(chapterId) {
  return request({
    url: '/rc/meeting/listCode/' + chapterId,
    method: 'get'
  })
}

// 查询会议列表
export function listMeeting(query) {
  return request({
    url: '/rc/meeting/list',
    method: 'get',
    params: query
  })
}

// 查询会议详细
export function getMeeting(id) {
  return request({
    url: '/rc/meeting/' + id,
    method: 'get'
  })
}

// 新增会议
export function addMeeting(data) {
  return request({
    url: '/rc/meeting',
    method: 'post',
    data: data
  })
}

// 修改会议
export function updateMeeting(data) {
  return request({
    url: '/rc/meeting',
    method: 'put',
    data: data
  })
}

// 删除会议
export function delMeeting(id) {
  return request({
    url: '/rc/meeting/' + id,
    method: 'delete'
  })
}
